/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"time"
)

// checks if the AddSegmentGroupRequestSegment type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AddSegmentGroupRequestSegment{}

// AddSegmentGroupRequestSegment struct for AddSegmentGroupRequestSegment
type AddSegmentGroupRequestSegment struct {
	Key string `json:"key"`
	ExpiresAt *time.Time `json:"expires_at,omitempty"`
	SubType string `json:"sub_type"`
}

// NewAddSegmentGroupRequestSegment instantiates a new AddSegmentGroupRequestSegment object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAddSegmentGroupRequestSegment(key string, subType string) *AddSegmentGroupRequestSegment {
	this := AddSegmentGroupRequestSegment{}
	this.Key = key
	this.SubType = subType
	return &this
}

// NewAddSegmentGroupRequestSegmentWithDefaults instantiates a new AddSegmentGroupRequestSegment object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAddSegmentGroupRequestSegmentWithDefaults() *AddSegmentGroupRequestSegment {
	this := AddSegmentGroupRequestSegment{}
	return &this
}

// GetKey returns the Key field value
func (o *AddSegmentGroupRequestSegment) GetKey() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Key
}

// GetKeyOk returns a tuple with the Key field value
// and a boolean to check if the value has been set.
func (o *AddSegmentGroupRequestSegment) GetKeyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Key, true
}

// SetKey sets field value
func (o *AddSegmentGroupRequestSegment) SetKey(v string) {
	o.Key = v
}

// GetExpiresAt returns the ExpiresAt field value if set, zero value otherwise.
func (o *AddSegmentGroupRequestSegment) GetExpiresAt() time.Time {
	if o == nil || IsNil(o.ExpiresAt) {
		var ret time.Time
		return ret
	}
	return *o.ExpiresAt
}

// GetExpiresAtOk returns a tuple with the ExpiresAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddSegmentGroupRequestSegment) GetExpiresAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.ExpiresAt) {
		return nil, false
	}
	return o.ExpiresAt, true
}

// HasExpiresAt returns a boolean if a field has been set.
func (o *AddSegmentGroupRequestSegment) HasExpiresAt() bool {
	if o != nil && !IsNil(o.ExpiresAt) {
		return true
	}

	return false
}

// SetExpiresAt gets a reference to the given time.Time and assigns it to the ExpiresAt field.
func (o *AddSegmentGroupRequestSegment) SetExpiresAt(v time.Time) {
	o.ExpiresAt = &v
}

// GetSubType returns the SubType field value
func (o *AddSegmentGroupRequestSegment) GetSubType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SubType
}

// GetSubTypeOk returns a tuple with the SubType field value
// and a boolean to check if the value has been set.
func (o *AddSegmentGroupRequestSegment) GetSubTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SubType, true
}

// SetSubType sets field value
func (o *AddSegmentGroupRequestSegment) SetSubType(v string) {
	o.SubType = v
}

func (o AddSegmentGroupRequestSegment) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AddSegmentGroupRequestSegment) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["key"] = o.Key
	if !IsNil(o.ExpiresAt) {
		toSerialize["expires_at"] = o.ExpiresAt
	}
	toSerialize["sub_type"] = o.SubType
	return toSerialize, nil
}

type NullableAddSegmentGroupRequestSegment struct {
	value *AddSegmentGroupRequestSegment
	isSet bool
}

func (v NullableAddSegmentGroupRequestSegment) Get() *AddSegmentGroupRequestSegment {
	return v.value
}

func (v *NullableAddSegmentGroupRequestSegment) Set(val *AddSegmentGroupRequestSegment) {
	v.value = val
	v.isSet = true
}

func (v NullableAddSegmentGroupRequestSegment) IsSet() bool {
	return v.isSet
}

func (v *NullableAddSegmentGroupRequestSegment) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAddSegmentGroupRequestSegment(val *AddSegmentGroupRequestSegment) *NullableAddSegmentGroupRequestSegment {
	return &NullableAddSegmentGroupRequestSegment{value: val, isSet: true}
}

func (v NullableAddSegmentGroupRequestSegment) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAddSegmentGroupRequestSegment) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


